Imports System.Collections.Generic
Imports Telerik.WebControls

Partial Class DefaultVB
    Inherits System.Web.UI.Page
    Private ReadOnly Property DragAndDropStack() As Stack(Of String)
        Get
            Dim stack As Stack(Of String) = CType(Session("DragAndDropStack"), Stack(Of String))

            If stack Is Nothing Then
                stack = New Stack(Of String)()

                Session("DragAndDropStack") = stack
            End If

            Return stack
        End Get
    End Property
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If (Not Me.IsPostBack) Then
            DragAndDropStack.Clear()

            Me.RadTreeView1.LoadContentFile("~/tree.xml")
        End If
    End Sub
    Protected Sub RadTreeView1_NodeDrop(ByVal o As Object, ByVal e As RadTreeNodeEventArgs)
        DragAndDropStack.Push(Me.RadTreeView1.GetXml())
        Me.Button1.Enabled = True

        Dim sourceNode As RadTreeNode = e.SourceDragNode
        Dim destNode As RadTreeNode = e.DestDragNode
        Dim dropPosition As RadTreeViewDropPosition = e.DropPosition

        If destNode IsNot Nothing Then
            If sourceNode.TreeView.SelectedNodes.Count <= 1 Then
                PerformDragAndDrop(dropPosition, sourceNode, destNode)
            ElseIf sourceNode.TreeView.SelectedNodes.Count > 1 Then
                For Each node As RadTreeNode In sourceNode.TreeView.SelectedNodes
                    PerformDragAndDrop(dropPosition, node, destNode)
                Next node
            End If

            destNode.Expanded = True

            sourceNode.TreeView.ClearSelectedNodes()
        End If
    End Sub
    Private Shared Sub PerformDragAndDrop(ByVal dropPosition As RadTreeViewDropPosition, ByVal sourceNode As RadTreeNode, ByVal destNode As RadTreeNode)
        If sourceNode.Equals(destNode) OrElse sourceNode.IsAncestorOf(destNode) Then
            Return
        End If

        sourceNode.Owner.Nodes.Remove(sourceNode)

        Select Case dropPosition
            Case RadTreeViewDropPosition.Over
                ' child
                If (Not sourceNode.IsAncestorOf(destNode)) Then
                    destNode.Nodes.Add(sourceNode)
                End If

            Case RadTreeViewDropPosition.Above
                ' sibling - above                    
                destNode.InsertBefore(sourceNode)

            Case RadTreeViewDropPosition.Below
                ' sibling - below
                destNode.InsertAfter(sourceNode)
        End Select
    End Sub
    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As EventArgs)
        Dim xmlString As String = DragAndDropStack.Pop()

        Me.RadTreeView1.LoadXmlString(xmlString)

        If DragAndDropStack.Count = 0 Then
            Me.Button1.Enabled = False
        End If
    End Sub
End Class
